BIN=../sda_dir/sda_flex-7.1.2/bin
#VMD=/sw/mcm/app/vmd/vmd-1.9.1-amd64/vmd
VMD=vmd
AUXI=../sda_dir/sda_flex-7.1.2/auxi


#convert apbs grids
$BIN/convert_grid ../data/barnase.apbs.grd ../data/barnase.ep.grd -scale 0.6 -convert
$BIN/convert_grid ../data/barstar.apbs.grd ../data/barstar.ep.grd -scale 0.6 -convert
$BIN/convert_grid ../data/barnase_mut.apbs.grd ../data/barnase_mut.ep.grd -scale 0.6 -convert

#remove hydrogens
$VMD -dispdev none < ../bin/vmd.tcl

$BIN/ecm_all -fp ../data/barnase_noh.pdb -fg ../data/barnase.ep.grd -is 100. -rc 1.0 -fe ../data/barnase.echa > barnase.ecm.out
$BIN/ecm_all -fp ../data/barstar_noh.pdb -fg ../data/barstar.ep.grd -is 100. -rc 1.0 -fe ../data/barstar.echa > barstar.ecm.out
$BIN/ecm_all -fp ../data/barnase_mut_noh.pdb -fg ../data/barnase_mut.ep.grd -is 100. -rc 1.0 -fe ../data/barnase_mut.echa > barnase_mut.ecm.out

cp ../data/barnase_noh.pdb ../data/tmp.pdb
$BIN/make_edhdlj_grid -ed ../data/ed.in -hd ../data/hd.in
mv ../data/tmp_ed.grd ../data/barnase.ed.grd; mv ../data/tmp_hd.grd ../data/barnase.hd.grd
rm ../data/tmp.pdb

cp ../data/barstar_noh.pdb ../data/tmp.pdb
$BIN/make_edhdlj_grid -ed ../data/ed.in -hd ../data/hd.in
mv ../data/tmp_ed.grd ../data/barstar.ed.grd; mv ../data/tmp_hd.grd ../data/barstar.hd.grd
rm ../data/tmp.pdb

cp ../data/barnase_mut_noh.pdb ../data/tmp.pdb
$BIN/make_edhdlj_grid -ed ../data/ed.in -hd ../data/hd.in
mv ../data/tmp_ed.grd ../data/barnase_mut.ed.grd; mv ../data/tmp_hd.grd ../data/barnase_mut.hd.grd
rm ../data/tmp.pdb

$BIN/nda-pairs ../data/barnase_noh.pdb ../data/barstar_noh.pdb
$BIN/rxna2rxnaC 1.rxna 2.rxna ../data/prot12.rxna 6.5 1
rm 1.rxna 2.rxna fort.99;

$BIN/nda-pairs ../data/barnase_mut_noh.pdb ../data/barstar_noh.pdb
$BIN/rxna2rxnaC 1.rxna 2.rxna ../data/prot12_mut.rxna 6.5 1
rm 1.rxna 2.rxna fort.99;


#first 'standard' sda run
$BIN/sda_flex ../data/sda.in > sda.out
$BIN/trajectory2dcd trajectories trajectories.dcd -pdb1 ../data/barnase_noh.pdb -pdb2 ../data/barstar_noh.pdb 
#$BIN/nos2rates sda.out > rates
$AUXI/Bootstrap_multiCPU.py -i assoc_bootstrap.log -o assoc_rates_1.out -n 100
mv assoc_bootstrap.log assoc_bootstrap_1.log
rm fort.*

exit 0
