/*
 * ProteinDataBankStructure.cpp
 *
 *  Created on: Dec 23, 2011
 *      Author: oezboyma
 */

#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string.h>
#include <sstream>
#include "ProteinDataBankStructure.h"
using namespace std;

Atom::~Atom() {;};
Residue::~Residue()
{
	delete[] Atoms;
}
PDB::~PDB()
{
	delete[] Residues;
}

int PDB::Read_PDB_File(ifstream &pdbfile, int MAXNUM){

	int total_atom_counter = 0 ;
	int residue_atom_counter = 0 ;
	int residue_counter = 0 ;

	int residue_number, residue_number_prev;

	string line, ATOM_string;
	string ATOMname = "ATOM";
	//string List_Atom_Type[MAXNUM] ;
	string List_Atom_Type[MAXNUM] ;
	string List_Residue_Type[MAXNUM] ;
	int List_Atom_Numbers[MAXNUM] ;
	float List_X_Coords[MAXNUM] ;
	float List_Y_Coords[MAXNUM] ;
	float List_Z_Coords[MAXNUM] ;

	do{
		getline(pdbfile, line) ;
		ATOM_string = line.substr(0, 4) ;
	}while (ATOM_string.compare(ATOMname) == 1) ;
	//cout << line << endl;

	for (int i = 0 ; i < MAXNUM; i++){
		//List_Atom_Type[i] = line.substr(11, 7);
		List_Atom_Type[i] = line.substr(13, 1);
		List_Residue_Type[i] =  line.substr(17, 3);
		stringstream(line.substr(30,8)) >> List_X_Coords[i];
		stringstream(line.substr(38,8)) >> List_Y_Coords[i];
		stringstream(line.substr(46,8)) >> List_Z_Coords[i];

		stringstream(line.substr(22,4)) >> residue_number;
		//cout << line.substr(20,6) << endl;
		if (i == 0)
			residue_number_prev = residue_number;

		if (residue_number != residue_number_prev){
			//cout << i << endl;
			List_Atom_Numbers[residue_counter] = residue_atom_counter ;
			total_atom_counter += residue_atom_counter ;
			residue_atom_counter = 0 ;
			residue_counter++ ;
			residue_number_prev = residue_number;
		}
		residue_atom_counter++;

		if (! getline(pdbfile, line).eof()){
			if ((line.substr(0,4)).compare(ATOMname) == 0){
				continue;
			}
			else{
				List_Atom_Numbers[residue_counter] = residue_atom_counter ;
				total_atom_counter += residue_atom_counter ;
				residue_counter++ ;
				break;
			}

		}

		else
			break;
	}

	Number_of_Atoms = total_atom_counter;
	Number_of_Residues = residue_counter;

	Residues = new Residue [residue_counter];

	int new_counter = 1;

	for (int i = 0; i < residue_counter; i++){
		Residues[i].Number_of_Atoms = List_Atom_Numbers[i];
		Residues[i].Residue_Type = List_Residue_Type[new_counter];
		Residues[i].Atoms = new Atom [Residues[i].Number_of_Atoms];
		for (int j = 0; j < Residues[i].Number_of_Atoms; j++){
			Residues[i].Atoms[j].Atom_Number = new_counter;
			Residues[i].Atoms[j].Atom_Type = List_Atom_Type[new_counter-1];
			Residues[i].Atoms[j].Coord.X = List_X_Coords[new_counter-1];
			Residues[i].Atoms[j].Coord.Y = List_Y_Coords[new_counter-1];
			Residues[i].Atoms[j].Coord.Z = List_Z_Coords[new_counter-1];
			new_counter++;
		}
	}

	return 0;
}

Atom::Coordinates PDB::Center_of_Geometry(){
	Atom::Coordinates temp;
	temp.X = 0;
	temp.Y = 0;
	temp.Z = 0;
	for (int i = 0; i < Number_of_Residues; i++){
		 temp.X += Residues[i].Center_of_Geometry().X;
		 temp.Y += Residues[i].Center_of_Geometry().Y;
		 temp.Z += Residues[i].Center_of_Geometry().Z;
	}
	temp.X /= Number_of_Residues;
	temp.Y /= Number_of_Residues;
	temp.Z /= Number_of_Residues;
	return temp;
}

Atom::Coordinates Residue::Center_of_Geometry(){
	Atom::Coordinates temp;
	temp.X = 0;
	temp.Y = 0;
	temp.Z = 0;
	for (int j = 0; j < Number_of_Atoms; j++)
	{
		temp.X += Atoms[j].Coord.X;
		temp.Y += Atoms[j].Coord.Y;
		temp.Z += Atoms[j].Coord.Z;
	}
	temp.X /= Number_of_Atoms;
	temp.Y /= Number_of_Atoms;
	temp.Z /= Number_of_Atoms;
	return temp;
}

float Atom::Mass_of_Atom()
{
	float radius;
	if (Atom_Type.compare("H") == 0){
		radius = 1.20;
	}
	else if (Atom_Type.compare("C") == 0){
		radius = 1.90;
	}
	else if (Atom_Type.compare("N") == 0){
		radius = 1.625;
	}
	else if (Atom_Type.compare("O") == 0){
		radius = 1.48;
	}
	else if (Atom_Type.compare("P") == 0){
		radius = 1.90;
	}
	else if (Atom_Type.compare("S") == 0){
		radius = 1.85;
	}
	else if (Atom_Type.compare("F") == 0){
		radius = 0.64;
	}
	else if (Atom_Type.compare("Z") == 0){
		radius = 1.38;
	}
	else if (Atom_Type.compare("B") == 0){
		radius = 1.95;
	}
	else if (Atom_Type.compare("I") == 0){
		radius = 2.15;
	}
	else{
		radius = 1.90;
	}
	return radius;
}

/*Atom iterate::begin()
{
	iter = start;
}

iterate::iterate(PDB * THIS)
{
	iter = THIS->Residues[0].Atoms;//->Residues[0].Atoms[0];
	start = (Atom*) iter;
}

Atom iterate::operator++()
{
	((PDB*) iter)->Residues[0].Atoms;
	this->iter++;
}*/