/*
 * ProteinDataBankStructure.h
 *
 *  Created on: Dec 23, 2011
 *      Author: oezboyma
 */

#ifndef PROTEINDATABANKSTRUCTURE_H_
#define PROTEINDATABANKSTRUCTURE_H_

#include <stdlib.h>
#include <sstream>
#include <string>
using namespace std;

class PDB;

class Atom
{
	Atom() {;};
	~Atom();
	friend class PDB;
	friend class Residue;
	//friend class iterate;
	string Atom_Type;
	int Atom_Number;
public:
	struct Coordinates
	{
		float X;
		float Y;
		float Z;
	} Coord;

    float Mass_of_Atom ();
	int Read_PDB_File();
};

class Residue
{
	Residue() {;};
	~Residue();
	friend class PDB;
	//friend class iterate;
	
	string Residue_Type;
	
public:
    int Number_of_Atoms;
    Atom * Atoms;
	int Read_PDB_File();
	Atom::Coordinates Center_of_Geometry();
};

class PDB
{
	//friend class iterate;
public:
	PDB() {;};
	~PDB();

	int Number_of_Residues;
	int Number_of_Atoms;
	Residue * Residues;
	
public:
	int Read_PDB_File(ifstream&, int);
	Atom::Coordinates Center_of_Geometry();
	int Get_Coordinates();	
};

/*class iterate
{
private:
    Atom * start;
	Atom * finish;
	void * iter;
	Atom begin();
	Atom end();
	iterate (PDB * THIS);
	Atom operator++ ();
};*/

#endif /* PROTEINDATABANKSTRUCTURE_H_ */
