//============================================================================
// Name        : RegularToDTGridConvertor.cpp
// Author      : Musa Ozboyaci
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

// Loading the libraries
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string.h>
#include <sstream>
#include <math.h>
#include <sys/stat.h>
#include "Write_dtgrdFile_ASCII.h"
#include "Write_dtgrdFile_Binary.h"
#include "UHBDgrd.h"
//#include <list>

using namespace std;

template <typename T1, typename T2>
int Generate_DTGrid(T2 *** Skin_Grid, T1 *** UHBD_Grid, int LengthX, int LengthY, int LengthZ, \
list<T1>& Value, list<int>& xcoord,list<int>& ycoord,list<int>& zcoord,\
list<int>& acc,list<int>& acc2D,list<int>& acc3D,list<int>& proj1D,list<int>& proj2D){
	
	cout << "Generating the dtgrid structure ..." << endl;
	int componentY, componentZ;
	int prev_componentY, prev_componentZ;

	prev_componentY = -1;

	for (int i=0;i<LengthX;i++){
		prev_componentZ = -1;
		componentY = 0;
		for (int j=0; j<LengthY; j++){
			componentZ = 0;
			for (int k=0; k<LengthZ; k++){

				if (Skin_Grid[i][j][k] == true){
					Value.push_back(UHBD_Grid[i][j][k]);

				    if (k==0){
						componentZ += 1;
						zcoord.push_back(k);
						acc.push_back(((int) Value.size())-1);
						proj1D.push_back(((int) Value.size())-1);
						proj1D.push_back(((int) zcoord.size())-1);
					}
				    else{
						if (Skin_Grid[i][j][k-1] == false){
							componentZ += 1;
							zcoord.push_back(k);
							acc.push_back(((int) Value.size())-1);
							if (componentZ == 1){
								proj1D.push_back(((int) Value.size())-1);
								proj1D.push_back(((int) zcoord.size())-1);
							}
						}
					}
				}
				if (k == (LengthZ-1)){
					if (Skin_Grid[i][j][k] == true){
						zcoord.push_back(k);
					}
					else{
						if (Skin_Grid[i][j][k-1] == true){
							zcoord.push_back((k-1));
						}
					}
				}
				else{
					if (k != 0){
						if (Skin_Grid[i][j][k-1] == true){
							if (Skin_Grid[i][j][k] == false){
								zcoord.push_back((k-1));
							}
						}
					}
				}
			}
			
			if (j==0){
				if (componentZ > 0){
					ycoord.push_back(j);
					acc2D.push_back(((int) proj1D.size())-2);
					componentY += 1;
					proj2D.push_back(((int) proj1D.size())-2);
					proj2D.push_back(((int) ycoord.size())-1);

				}
			}
			else{
				if (prev_componentZ == 0){
					if (componentZ > 0){
						ycoord.push_back(j);
						acc2D.push_back(((int) proj1D.size())-2);
						componentY += 1;
						if (componentY == 1){
							proj2D.push_back(((int) proj1D.size())-2);
							proj2D.push_back(((int) ycoord.size())-1);
						}
					}
				}
			}
			if (j == (LengthY-1)){
				if (componentZ > 0){
					ycoord.push_back(j);
				}
				else{
					if (prev_componentZ > 0){
						ycoord.push_back(j-1);
					}
				}
			}
			else{
				if (prev_componentZ > 0){
					if (componentZ == 0){
						ycoord.push_back(j-1);
					}
				}
			}
			prev_componentZ = componentZ;
		}
		if (i == 0){
			if (componentY > 0){
				xcoord.push_back(i);
				acc3D.push_back(((int) proj2D.size())-2);
			}
		}
		else{
			if (prev_componentY == 0){
				if (componentY > 0){
					xcoord.push_back(i);
					acc3D.push_back(((int) proj2D.size())-2);
				}
			}
		}
		if (i == (LengthX-1)){
			if (componentY > 0){
				xcoord.push_back(i);
			}
			else{
				if (prev_componentY > 0){
					xcoord.push_back(i-1);
				}
			}
		}
		else{
			if (prev_componentY > 0){
				if (componentY == 0){
					xcoord.push_back(i-1);
				}
			}
		}
		prev_componentY = componentY;
	}
	cout << "dtgrid structure is generated successfully!" << endl;
	return 0;
}

void Usage(void)
{
	cout << endl;
	cout << "**************************************************************************" << endl;
	cout << endl;
	cout << "                     UHBD TO DTGRID FILE CONVERTOR                        " << endl;
	cout << endl;
	cout << "**************************************************************************" << endl;
	cout << endl;
	cout << "Usage:" << endl;
	cout << "./UHBD2dtgrid -g 'UHBD_file' -p 'PDB_file' -f 'File_type'" << endl;
	cout << endl;
	cout << "Option\t Opt?\t Description" << endl;
	cout << "-----------------------------------------------------------------------------------------" << endl;
	cout << "-g\t No\t The UHBD file name to be converted into dtgrid" << endl;
	cout << "-p\t No\t The PDB file name to be used to generate the molecular skin" << endl;
	cout << "-f\t No\t The output file type" << endl;
	cout << "  \t \t There are two options: Binary and ASCII" << endl;
	cout << "  \t \t You can save your dtgrid using the format you want" << endl;
	cout << "-o\t Yes\t The name of the outputing *.dtgrid file name" << endl;
	cout << "  \t \t The grid file will be named as 'dt.dtgrid' unless this option is used" << endl;
	cout << "-s\t Yes\t The thickness of the skin around the surface of the molecule" << endl;
	cout << "  \t \t A default value of 2.0 Angstrom will be used unless this option is used" << endl;
	cout << "-pr\t Yes\t The size of the probe used to compute the molecular skin" << endl;
	cout << "  \t \t A default value of 1.7 Angstrom will be used unless this option is used" << endl;
	cout << "-h\t \t Displays the usage information and terminates the execution!" << endl;
	cout << endl;
}

int main(int argc, char *argv[]) 
{
	char *UHBDFILE = NULL;
	char *PDBFILE  = NULL;
	char *FILETYPE = NULL;

	//Default output name
	char output_file_name [] = "uhbd2.dtgrd";
	char *  OUTPUT ;
	OUTPUT = output_file_name;

	//Default values for the skin and the probe
	float skin_size = 2.0;
	float probe_size = 1.7;
		
	for (int c = 1; c < argc; c++)
	{
		if (strcmp(argv[c], "-h") == 0)
		{
			Usage();
			return 0;
		}
		if (strcmp(argv[c], "--help") == 0)
		{
			Usage();
			return 0;
		}
		if (strcmp(argv[c], "-g") == 0)
 		{
			UHBDFILE = argv[c+1];
		}
		if (strcmp(argv[c], "-p") == 0)
		{
			PDBFILE = argv[c+1];
		}
		if (strcmp(argv[c], "-f") == 0)
		{
			FILETYPE = argv[c+1];
			if (strcmp(FILETYPE, "ascii") != 0 or strcmp(FILETYPE, "ASCII") != 0 or \
					strcmp(FILETYPE, "Ascii") != 0 or strcmp(FILETYPE, "binary") != 0 or \
					strcmp(FILETYPE, "BINARY") != 0 or strcmp(FILETYPE, "Binary") != 0)
				{
					cout << "The file type you entered is not supported!" << endl;
					cout << "Please check your input parameters" << endl;
					cout << "Try -h option to get the usage information" << endl;
					cout << "Exiting..." << endl;
				}
		}
		//Optional parameters
		if (strcmp(argv[c], "-o") == 0)
		{
			OUTPUT = argv[c+1];
		}
		if (strcmp(argv[c], "-s") == 0)
		{
			skin_size = atof(argv[c+1]);
		}
		if (strcmp(argv[c], "-pr") == 0)
		{
			probe_size = atof(argv[c+1]);
		}
	}

	if (UHBDFILE == NULL){
		cout << "Please input UHBD file name!" << endl;
		cout << "Try -h option to get the usage information" << endl;
		cout << "Exiting..." << endl;
		return 0;
	}
	if (PDBFILE == NULL){
		cout << "Please input PDB file name!" << endl;
		cout << "Try -h option to get the usage information" << endl;
		cout << "Exiting..." << endl;
		return 0;
	}
	if (FILETYPE == NULL){
		cout << "Please input UHBD file type!" << endl;
		cout << "Try -h option to get the usage information" << endl;
		cout << "Exiting..." << endl;
		return 0;
	}
	
	cout << endl;
	cout << "**************************************************************************" << endl;
	cout << endl;
	cout << "                     UHBD TO DTGRID FILE CONVERTOR                        " << endl;
	cout << endl;
	cout << "**************************************************************************" << endl;
	cout << endl;
	

	UHBD<double> * uhbd;
	uhbd = new UHBD<double>(UHBDFILE);
	uhbd->loadpdb(PDBFILE);
	uhbd->Generate_Skin(skin_size, probe_size);

	list<double> Value;
	list<int> xcoord;
	list<int> ycoord;
	list<int> zcoord;
	list<int> acc;
	list<int> acc2D;
	list<int> acc3D;
	list<int> proj1D;
	list<int> proj2D;
	

	Generate_DTGrid<double>(uhbd->Skin,uhbd->Grid,uhbd->dim.i,uhbd->dim.j,\
			uhbd->dim.k,Value,xcoord,ycoord,zcoord,acc,acc2D,acc3D,proj1D,proj2D);
	
	// Initialize the output *dtgrd file and write the headers

	if (strcmp(FILETYPE,"ascii") == 0 or strcmp(FILETYPE,"Ascii") == 0 or strcmp(FILETYPE,"ASCII") == 0){
		FILE* output;
		//IF the output file already exists?
		/*struct stat st;
		if(stat(OUTPUT,&st) == 1){
			char system_in[] = "mv %c %c.1", OUTPUT, OUTPUT;
			system("mv %c %c.1", OUTPUT, OUTPUT);
		}*/
		output = fopen(OUTPUT,"w");
		fprintf(output, "Potential grid                                                          \n");
		fprintf(output, "%12.5E%12.5E%7d%7d%7d%7d%7d\n", uhbd->scale, \
		uhbd->dummy1, uhbd->grdflag, uhbd->idummy1, uhbd->dim.k, uhbd->one, uhbd->dim.k);
		fprintf(output, "%7d%7d%7d%12.5E%12.5E%12.5E%12.5E\n", uhbd->dim.i, uhbd->dim.j, \
		uhbd->dim.k, uhbd->spacing, uhbd->o.x, uhbd->o.y, uhbd->o.z);
		fprintf(output, "%12.5E%12.5E%12.5E%12.5E\n", uhbd->dummy2, uhbd->dummy3, uhbd->dummy4, uhbd->dummy5);
		fprintf(output, "%12.5E%12.5E%7d%7d\n", uhbd->dummy6, uhbd->dummy7, uhbd->idummy2, uhbd->idummy3);
		cout << "Writing the dtgrid to the output file ..." << endl;
		Write_dtgrdFile_ASCII(output, Value, xcoord, ycoord, zcoord, acc, acc2D, acc3D, proj1D, proj2D);
		fclose(output);
	}
	
	if (strcmp(FILETYPE,"binary") == 0){
		fstream output("./binary.dtgrd",ios::out|ios::binary|ios::app); 
		cout << "dtgrid is being written to the output file ..." << endl;
		Write_dtgrdFile_Binary(output, Value, xcoord, ycoord, zcoord, acc, acc2D, acc3D, proj1D, proj2D);
		output.close();
	}
	delete uhbd;
	cout << "Exiting" << endl;
	return 0;
}
