#!/usr/bin/python
# 
#
# -------------------------------------------------------------------
# PDPIPE V 1.0
# Author: Domantas Motiejunas, Copyright (c) 2007
# EML Research
# domantas.motiejunas@eml-r.villa-bosch.de
# 
# -------------------------------------------------------------------
import os, sys

def printUsage():
  print """
  ===================================================================
  USE CASE
    Plot RMSD of docked protein 2 file
    
  USAGE
    ./this.py title inputFile outputFile
    
  inputFile - list of RMSDs
  outputFile - *png image file name
  ===================================================================
  """


def makeGnuPlotScript(title, fileIn, fileOut):
  return """
set term png
set output '"""+fileOut+"""'
set grid
set title '"""+title+"""'
set xlabel 'Orientation Number'
set ylabel 'RMSD'
unset key
plot '"""+fileIn+"""'
"""

fileOut = 'none'
fileIn  = 'none'
title = 'none'
tmpFile = 'tmpGnuplotScript.scr'

try:
  title  = sys.argv[1]
  fileIn = sys.argv[2]
  fileOut= sys.argv[3]
except IndexError:
  printUsage()
  sys.exit(1)
  
fileOutObj = open(tmpFile, 'w')
fileOutObj.write(makeGnuPlotScript(title, fileIn, fileOut))
fileOutObj.close()
os.system('gnuplot '+tmpFile)
os.system('rm '+tmpFile)  

