#!/usr/bin/python
# 
# this one goes to folders with printed out results and 
# makes a plot with gnuplot,
#
# -------------------------------------------------------------------
# PDPIPE V 1.0
# Author: Domantas Motiejunas, Copyright (c) 2007
# EML Research
# domantas.motiejunas@eml-r.villa-bosch.de
# 
# -------------------------------------------------------------------
import os, sys

def printUsage():
  print """
  ===================================================================
  USE CASE
    Plot bins illustrating the cluster formation
    
  USAGE
    ./this.py title inputFile outputFile
    
  inputFile  - output of bin analysis from clust program
  outputFile - *png image file name
  ===================================================================
  """


def makeGnuPlotScript(title, fileIn, fileOut):
  return """
set term png
set output '"""+fileOut+"""'
set grid
set title '"""+title+"""'
set xlabel 'Bins'
set ylabel 'Number of Clusters'
unset key
plot '"""+fileIn+"""' with lines
"""
#plot '< tail -100 """+fileIn+"""' with steps lw 2 lt 1 
#"""

fileOut = 'none'
fileIn  = 'none'
title = 'none'
tmpFile = 'tmpGnuplotScript.scr'

try:
  title  = sys.argv[1]
  fileIn = sys.argv[2]
  fileOut= sys.argv[3]
except IndexError:
  printUsage()
  sys.exit(1)
  
fileOutObj = open(tmpFile, 'w')
fileOutObj.write(makeGnuPlotScript(title, fileIn, fileOut))
fileOutObj.close()
os.system('gnuplot '+tmpFile)
os.system('rm '+tmpFile)  

