c------------------------------------------------------------------------
c   program sda <c
c>  \version{version 6.00 (2010)}
c> <c
c>  Copyright (c) 2009, 2010
c>  Heidelberg Institute of Theoretical Studies (HITS, www.h-its.org)
c>        formerly EML Research gGmbH (EML-R www.eml-research.de)
c>  Schloss-Wolfsbrunnenweg 35
c>  69118 Heidelberg, Germany
c>
c>  Copyright (c) 2000, 2003 <c
c>  European Molecular Biology Laboratory <c
c>  Meyerhofstr. 1, Postfach 10.2209 <c
c>  D-69012, Heidelberg, Germany <c
c>  <c
c>  Please send your contact address to get information on updates and
c>  new features to "mcmsoft@h-its.org". Questions will be
c>  answered as soon as possible.
c>
c>  References:
c>     R.R. Gabdoulline, R.C. Wade.
c>  Brownian dynamics simulation of protein-protein diffusional encounter.
c>  (1998) Methods, 14, 329-341.
c>  for additional references see http://mcm.h-its.org/mcmsoft/sda/6.00/#ref
c>
c>  \authors{Authors: R.R.Gabdoulline, R.C.Wade}
c
      IMPLICIT REAL*8 (a-h,o-z)

c compiler complains, not used
c      parameter(na1mx=25000)
      CHARACTER*128 string1,string2
      CHARACTER*128 arg
      CHARACTER*6 arg2
      CHARACTER*128 rxna1f,rxna2f,p12rxna
      REAL*8 dist
      INTEGER inonspec

      IF (iargc().LT.2) THEN
        print *,"The script converts the two *.rxna files from SDA 5"
        print *,"to the new format used in SDA 6."
      print *,"Run the programm with the two filenames as parameter"
      print *,"arguments:"
      print *,""
        print *,"   ./rxna2rxnaC p1.rxna p2.rxna [outFileName] [dist]",
     +          " [specificity]"
        print *,""
        print *,"   outFileName: name of the output file (p12.rxna)"
        print *,"   dist:        constraint distance, (6.00)"
        print *,"   specific: specifies if the constraint",
     +          " is specificity (=0)"
        print *,"             or nonspecific (=1), default 1"
        print *,""
        print *,"example commandline:"
        print *,"   ./rxna2rxnaC p1.rxna p2.rxna p12.rxna 6.00 0/"
      print *,""
          call exit(1)
      END IF

      dist = 6.00
      arg2 = 'CNONS'
      CALL getarg(1,rxna1f)
      CALL getarg(2,rxna2f)
      IF (iargc().GT.2) THEN 
        CALL getarg(3,p12rxna)
      ELSE
        p12rxna = 'p12c.rxna'
      END IF
      IF (iargc().GT.3) THEN
        CALL getarg(4,arg)
        read(arg,*) dist
      END IF
      IF (iargc().GT.4) THEN
        CALL getarg(5,arg)
        read(arg,*) inonspec
      END IF

c     if inonspec == 0 then all atoms are CSPEC
c     else CNONS
      if(inonspec.eq.0) arg2 = 'CSPEC'
      iurxn=77
      iurxn_2=88
      iurxn_out=99
      OPEN (iurxn_out,file=p12rxna)
      OPEN (iurxn,file=rxna1f,form='formatted',status='old')
      OPEN (iurxn_2,file=rxna2f,form='formatted',status='old')
      natr1 = 0
    1 CONTINUE
      READ (iurxn,'(a)',end=99) string1
      READ (iurxn_2,'(a)',end=99) string2
      IF (string1(1:4).NE.'ATOM') GO TO 1
      IF (string2(1:4).NE.'ATOM') GO TO 1
      natr1 = natr1 + 1
c      READ (string(1:54),502) (x1(m,nat1),m=1,3)
c      WRITE (6,'(a)') string1(1:69)
      WRITE (iurxn_out,5021) arg2,string1(1:54),dist,string2(1:54)
      GO TO 1
   99 CONTINUE
c compiler complains not used
c  502 FORMAT (14X,16X,3F8.3)
 5021 FORMAT ((a),'',(a),' |',f9.2,'| ',(a))
      CLOSE (iurxn)
      CLOSE (iurxn_2)
      CLOSE (iurxn_out)

      END
