!>  \version{version 7.1 (2015)}
!!
!>  Copyright (c) 2009, 2010, 2015
!>  Heidelberg Institute of Theoretical Studies (HITS, www.h-its.org)
!>        formerly EML Research gGmbH (EML-R )
!>  Schloss-Wolfsbrunnenweg 35
!>  69118 Heidelberg, Germany
!>
!>  Copyright (c) 2000, 2003
!>  European Molecular Biology Laboratory
!>  Meyerhofstr. 1, Postfach 10.2209
!>  D-69012, Heidelberg, Germany 
!>
!>  Please send your contact address to get information on updates and
!>  new features to "mcmsoft@h-its.org". Questions will be
!>  answered as soon as possible.
!>
!>  References (see also http://mcm.h-its.org/sda7/doc/doc_sda7/references.html):
!>
!>  Brownian dynamics simulation of protein-protein diffusional encounter.
!>
!>  (1998) Methods, 14, 329-341.
!>
!> Authors: M.Martinez, N.J.Bruce, J.Romanowska, D.B.Kokh, P.Mereghetti, R.R.Gabdoulline, M. Ozboyaci, S.Richter and R.C.Wade
!>
!>------------------------------------------------------------------------
!<

!> \file mod_interface.f90
!!
!! Define the equivalent of overloading functions. Only read_value() at this point

!> Module for overloading function
MODULE mod_interface


     !> Interface for read_value
     !!
     !! Declare version for float, double, integer, logical and string\n
     !! The implementation of the functions are in \ref read_group_file.f90
     !!
     !! extends to arrays
     !!
     interface read_value

            subroutine read_float ( buffer, fvalue )
                !implicit none
                CHARACTER( 200 ) :: buffer
                real ( kind = 4 ) :: fvalue
            end subroutine read_float

            subroutine read_double( buffer, dvalue )
                !implicit none
                CHARACTER( 200 ) :: buffer
                real ( kind=8 ) :: dvalue
            end subroutine read_double

             subroutine read_int ( buffer, ivalue )
                !implicit none
                CHARACTER( 200 ) :: buffer
                integer ivalue
             end subroutine read_int

             subroutine read_char(buffer,cvalue)
                !implicit none
                CHARACTER( 200 ) :: buffer
                character( 128 ) :: cvalue
             end subroutine read_char

             subroutine read_logical ( buffer, lvalue )
                !implicit none
                CHARACTER( 200 ) :: buffer
                logical :: lvalue
             end subroutine read_logical

             !! solve bug with pgf, allocatable was missing
             subroutine read_array_char( buffer,cvalue)
                CHARACTER( 200 ) :: buffer
                character, dimension(:), allocatable :: cvalue*(*)
             end subroutine read_array_char

    end interface read_value

    !contains, not working ??


END MODULE mod_interface
