!>  \version{version 7.1 (2015)}
!!
!>  Copyright (c) 2009, 2010, 2015
!>  Heidelberg Institute of Theoretical Studies (HITS, www.h-its.org)
!>        formerly EML Research gGmbH (EML-R )
!>  Schloss-Wolfsbrunnenweg 35
!>  69118 Heidelberg, Germany
!>
!>  Copyright (c) 2000, 2003
!>  European Molecular Biology Laboratory
!>  Meyerhofstr. 1, Postfach 10.2209
!>  D-69012, Heidelberg, Germany 
!>
!>  Please send your contact address to get information on updates and
!>  new features to "mcmsoft@h-its.org". Questions will be
!>  answered as soon as possible.
!>
!>  References (see also http://mcm.h-its.org/sda7/doc/doc_sda7/references.html):
!>
!>  Brownian dynamics simulation of protein-protein diffusional encounter.
!>
!>  (1998) Methods, 14, 329-341.
!>
!> Authors: M.Martinez, N.J.Bruce, J.Romanowska, D.B.Kokh, P.Mereghetti, R.R.Gabdoulline, M. Ozboyaci, S.Richter and R.C.Wade
!>
!>------------------------------------------------------------------------
!<

PROGRAM test_analytic

! include mod_analytic
use mod_setofgrid

type ( analytic ) :: anal
type ( sogrid ) :: set_grid
real (kind=8), dimension(:), allocatable :: list_stoke_radius


write(*,*) 'start'

write(*,*) '==============================================================='
write(*,*) 'Test mod_analytic '
call allocate_analytic( anal )

! in sda code, done by so_grid load_grid, assign the correct type
!this % pset_analytic_grid ( t_grid ) % type = t_grid
anal % type = 1

! set parameters, general all analytic
call set_analytic_params ( anal, 1.d0, 250., 2.d0 )

! Fill arrays
! set up all interactions with other types
!call fill_array_dh ( p_sogrid % pset_analytic_grid ( 1 ), list_stoke_radius )
allocate ( list_stoke_radius ( 1 ))
list_stoke_radius(1) = 0.d0
call fill_array_dh ( anal, list_stoke_radius )

! miss stoke_radius
!call print_analytic ( anal )
call info_analytic ( anal, .true.)


call deallocate_analytic ( anal )
call info_analytic ( anal )

write(*,*)
write(*,*) '==============================================================='
write(*,*) 'Test set_of_grid '

call allocate_sogrid ( set_grid )

call set_ofgrid_info( set_grid )

call delete_sogrid ( set_grid )



END PROGRAM test_analytic
