!>  \version{version 7.1 (2015)}
!!
!>  Copyright (c) 2009, 2010, 2015
!>  Heidelberg Institute of Theoretical Studies (HITS, www.h-its.org)
!>        formerly EML Research gGmbH (EML-R )
!>  Schloss-Wolfsbrunnenweg 35
!>  69118 Heidelberg, Germany
!>
!>  Copyright (c) 2000, 2003
!>  European Molecular Biology Laboratory
!>  Meyerhofstr. 1, Postfach 10.2209
!>  D-69012, Heidelberg, Germany 
!>
!>  Please send your contact address to get information on updates and
!>  new features to "mcmsoft@h-its.org". Questions will be
!>  answered as soon as possible.
!>
!>  References (see also http://mcm.h-its.org/sda7/doc/doc_sda7/references.html):
!>
!>  Brownian dynamics simulation of protein-protein diffusional encounter.
!>
!>  (1998) Methods, 14, 329-341.
!>
!> Authors: M.Martinez, N.J.Bruce, J.Romanowska, D.B.Kokh, P.Mereghetti, R.R.Gabdoulline, M. Ozboyaci, S.Richter and R.C.Wade
!>
!>------------------------------------------------------------------------
!<
!! in "fsignal_test.f90"
!!
!! to compile
!!
!! gcc -c csignum.c
!! gfortran -o test_signal csignum.o test_signal.f90

!! 15) SIGTERM
!! 2) SIGINT, works only like this

program fsignal_test

    external warning_sigterm ! Must declare as external
    external warning_sigint ! Must declare as external

    integer :: SIGINT, SIGTERM

    ! Install signal handlers, return immediately
    !call signal(SIGTERM, warning_sigterm)
    !call sigclear(SIGINT)

    SIGINT = 2
    call signal(SIGINT, warning_sigint)
    SIGTERM = 15
    call signal(SIGTERM, warning_sigterm)

    ! Do something that will take some time
!    write(*,*) 'before sleep'
!    call sleep(30)

    do while (.true.)
       call sleep(1)
        write(*,*) 'toto'
    end do
    write(*,*) 'after sleep quit normally'
end program fsignal_test

subroutine warning_sigterm
    write(*,*) 'Process interrupted (SIGTERM), exiting...'
    return
end subroutine warning_sigterm

subroutine warning_sigint
    write(*,*) 'Process interrupted (SIGINT), exiting...'
    return
end subroutine warning_sigint
