!>  \version{version 7.1 (2015)}
!!
!>  Copyright (c) 2009, 2010, 2015
!>  Heidelberg Institute of Theoretical Studies (HITS, www.h-its.org)
!>        formerly EML Research gGmbH (EML-R )
!>  Schloss-Wolfsbrunnenweg 35
!>  69118 Heidelberg, Germany
!>
!>  Copyright (c) 2000, 2003
!>  European Molecular Biology Laboratory
!>  Meyerhofstr. 1, Postfach 10.2209
!>  D-69012, Heidelberg, Germany 
!>
!>  Please send your contact address to get information on updates and
!>  new features to "mcmsoft@h-its.org". Questions will be
!>  answered as soon as possible.
!>
!>  References (see also http://mcm.h-its.org/sda7/doc/doc_sda7/references.html):
!>
!>  Brownian dynamics simulation of protein-protein diffusional encounter.
!>
!>  (1998) Methods, 14, 329-341.
!>
!> Authors: M.Martinez, N.J.Bruce, J.Romanowska, D.B.Kokh, P.Mereghetti, R.R.Gabdoulline, M. Ozboyaci, S.Richter and R.C.Wade
!>
!>------------------------------------------------------------------------
!<

!> \file mod_parameters_ecm.f90
!!
!! Define all input parameters used by ECM calculation

!> Parameters for ECM
MODULE mod_parameters_ecm

!> define input, output and internal parameters for ECM calculation
type param_ecm

    !> input parameters, from file or arguments
    !! @{
    character*128 :: pdb_name, test_charge_name, grid_name
    real ( kind=8 ) :: probes, skin, iostr, epssol, reg_charge
    integer :: reg_level
    !> @}

    !> output parameters
    !! @{
    character*128 :: eff_charge_name
    !> @}

    !> used as global variables, avoid passing a lot of arguments
    !! @{
    integer :: nb_points, nb_points_skin, natoms, nsite
    real ( kind=8 ) :: deb
    !> @}


end type param_ecm

END MODULE mod_parameters_ecm
