c------------------------------------------------------------------------
c   program sda <c
c>  \version{version 6.00 (2010)}
c> <c
c>  Copyright (c) 2009, 2010
c>  Heidelberg Institute of Theoretical Studies (HITS, www.h-its.org)
c>        formerly EML Research gGmbH (EML-R www.eml-research.de)
c>  Schloss-Wolfsbrunnenweg 35
c>  69118 Heidelberg, Germany
c>
c>  Copyright (c) 2000, 2003 <c
c>  European Molecular Biology Laboratory <c
c>  Meyerhofstr. 1, Postfach 10.2209 <c
c>  D-69012, Heidelberg, Germany <c
c>  <c
c>  Please send your contact address to get information on updates and
c>  new features to "mcmsoft@h-its.org". Questions will be
c>  answered as soon as possible.
c>
c>  References:
c>     R.R. Gabdoulline, R.C. Wade.
c>  Brownian dynamics simulation of protein-protein diffusional encounter.
c>  (1998) Methods, 14, 329-341.
c>  for additional references see http://mcm.h-its.org/mcmsoft/sda/6.00/#ref
c>
c>  \authors{Authors: R.R.Gabdoulline, R.C.Wade}
c
c------------------------------------------------------------------------
c  program da-pairs
c  version 4.23 (February 2000)
c
c------------------------------------------------------------------------
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                              c
c                STATISTICAL ANALYSIS OF HBONDS BETW 2 PROTEINS                c
c                                                                              c
c------------------------------------------------------------------------------c
c                           Version 1.00                                       c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c CURRENT VERSION NOTES                                                        c
c the check for accessibility of atom is commented out as CHECK                c
c in this treatment the program computes all donor-acceptor pairs              c
c and does not require the input pdb files to have an accessibility records    c
c   comment the CHECK out and use input pdb files with accessibility records   c
c   then the program will count only (accessible donor)-(accessible acceptors) c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      PARAMETER (namx=9999)
c. this is the maximal number of donor or acceptor atoms on each protein
      IMPLICIT REAL*8 (a-h,o-z)
      CHARACTER*40 pdb1f,pdb2f,rx1f,rx2f,arg
      DIMENSION x1a(3,namx),x2a(3,namx)
      DIMENSION s1a(namx),s2a(namx)
      DIMENSION x1d(3,namx),x2d(3,namx)
      DIMENSION s1d(namx),s2d(namx)
      INTEGER na1a(namx),na2a(namx),na1d(namx),na2d(namx)
      CHARACTER*30 aa1a(namx),aa1d(namx)
      CHARACTER*30 aa2a(namx),aa2d(namx)
c
      IF (iargc().LT.2) THEN
          WRITE (6,*) 'usage:'
          WRITE (6,*) 'nda-pairs pdb2f pdb2f cutmax'
          CALL exit
      END IF
      CALL getarg(1,pdb1f)
      CALL getarg(2,pdb2f)
      cutmax = 4.5d0
      IF (iargc().GE.3) THEN
          CALL getarg(3,arg)
          READ (arg,*) cutmax
      END IF
c
c       open(21,file='da.distance')
c       read(21,*,end=921) cutmax
c       goto 922
c 921  continue
c       write(21,*) cutmax
c       write(21,*) 'could not find the number here, using default'
c 922  continue
c       pdb1f='1.pdb'
c       pdb2f='2.pdb'
      rx1f = '1.rxna'
      rx2f = '2.rxna'
c       read(5,500) pdb1f
c       read(5,500) pdb2f
c       read(5,500) rx1f
c       read(5,500) rx2f
c  500 FORMAT (a)
c
c..this reads pdbs and makes a table of donors and acceptors
      CALL mkpar(pdb1f,dismx1,na1,x1a,s1a,na1a,aa1a,nd1,x1d,s1d,na1d,
     +           aa1d)
      WRITE (6,*) 'MOL 1 has',na1,'  acceptors and',nd1,'  donors'
      CALL mkpar(pdb2f,dismx2,na2,x2a,s2a,na2a,aa2a,nd2,x2d,s2d,na2d,
     +           aa2d)
      WRITE (6,*) 'MOL 2 has',na2,'  acceptors and',nd2,'  donors'
c
c
      cutmx2 = cutmax**2
c.. now we have don-acc of each molecule, let's make pairs
c.. for all 3 possibilities within cutmax distances
c
      OPEN (11,file=rx1f)
      OPEN (12,file=rx2f)
c
      WRITE (6,*) 'Searching within a cutoff',cutmax
c.. acceptor 1  ---   donor 2
      np = 0
      npa = 0
      WRITE (99,601)
      DO 11 i = 1,na1
          DO 11 j = 1,nd2
              npa = npa + 1
              dist = (x1a(1,i)-x2d(1,j))**2 + (x1a(2,i)-x2d(2,j))**2 +
     +               (x1a(3,i)-x2d(3,j))**2
              IF (dist.GT.cutmx2) GO TO 11
              np = np + 1
              WRITE (99,600) na1a(i), (x1a(m,i),m=1,3),s1a(i),
     +          -sqrt(dist),na2d(j), (x2d(m,j),m=1,3),s2d(j)
              WRITE (11,701) aa1a(i), (x1a(m,i),m=1,3),s1a(i)
              WRITE (12,701) aa2d(j), (x2d(m,j),m=1,3),s2d(j)
   11 CONTINUE
c
      WRITE (6,*) np,' out of possible',npa,' acc-don pairs found'
c.. donor 1  ---   acceptor 2
      np = 0
      npa = 0
      WRITE (99,602)
      DO 12 i = 1,nd1
          DO 12 j = 1,na2
              npa = npa + 1
              dist = (x1d(1,i)-x2a(1,j))**2 + (x1d(2,i)-x2a(2,j))**2 +
     +               (x1d(3,i)-x2a(3,j))**2
              IF (dist.GT.cutmx2) GO TO 12
              np = np + 1
              WRITE (99,600) na1d(i), (x1d(m,i),m=1,3),s1d(i),
     +          -sqrt(dist),na2a(j), (x2a(m,j),m=1,3),s2a(j)
              WRITE (11,701) aa1d(i), (x1d(m,i),m=1,3),s1d(i)
              WRITE (12,701) aa2a(j), (x2a(m,j),m=1,3),s2a(j)
   12 CONTINUE
      WRITE (6,*) np,' out of possible',npa,' don-acc pairs found'
c
c
  600 FORMAT (i5,3f8.3,f6.2,2x,f7.3,2x,i5,3f8.3,f6.2)
  601 FORMAT ('#   accep 1 -  donor 2')
  602 FORMAT ('#   donor 1 -  accep 2')
  701 FORMAT (a30,3f8.3,f6.2)
c

c compiler warning not used
c  100 CONTINUE
c..DONE !!
      CALL exit
      END
      SUBROUTINE mkpar(filnam,dismx,na,xa,sa,naa,aaa,nd,xd,sd,nad,aad)
      PARAMETER (namx=999)
      IMPLICIT REAL*8 (a-h,o-z)
      DIMENSION sa(namx),sd(namx)
      DIMENSION xa(3,namx),xd(3,namx)
      INTEGER naa(namx),nad(namx)
      CHARACTER*30 aaa(namx),aad(namx)
      DIMENSION xv(3),xc(3)
      CHARACTER*69 string
      CHARACTER*69 strin
      CHARACTER*40 filnam
      CHARACTER*4 atom
      CHARACTER*5 doname,acname
      LOGICAL donor,accep
      DATA atom/'ATOM'/
      DATA doname/'DONOR'/,acname/'ACCEP'/
c
      twopi = datan(1.d0)*8.d0
      iusas = 7
      OPEN (iusas,file=filnam,form='formatted',status='old')
c---read pdb file
      nat = 0
      DO m = 1,3
          xc(m) = 0.d0
      END DO
  500 FORMAT (a)
  501 FORMAT (3f8.3)
  502 FORMAT (3f8.3,f15.8)
    1 CONTINUE
      READ (iusas,500,end=99) string
      IF (string(1:4).NE.atom) GO TO 1
      nat = nat + 1
      READ (string(31:54),501) xv
      DO m = 1,3
          xc(m) = xc(m) + xv(m)
      END DO
      GO TO 1
   99 CONTINUE
      DO m = 1,3
          xc(m) = xc(m)/float(nat)
      END DO
c
      WRITE (6,601) nat,xc
  601 FORMAT (i5,'   atoms read, center:',3f8.3)
c
      REWIND (iusas)
      nat = 0
      nd = 0
      na = 0
      dismx = 0.0
    2 CONTINUE
      READ (iusas,500,end=98) string
      IF (string(1:4).NE.atom) GO TO 2
      nat = nat + 1
      READ (string(31:69),502) xv
      sas = 0.0
CHECK   read(string(31:69),502) xv,sas
      dist = (xv(1)-xc(1))**2 + (xv(2)-xc(2))**2 + (xv(3)-xc(3))**2
      IF (dist.GT.dismx) dismx = dist
CHECK     if(sas.le.0.d0) goto 2
c      call chdac(string(14:20),donor,accep,ndeg)
      CALL chdaca(string(14:20),donor,accep,ndeg)
      IF (donor) THEN
          nd = nd + 1
          nad(nd) = nat
          aad(nd) = string(1:30)
          strin = string
          WRITE (strin(1:5),500) doname
          WRITE (6,500) strin
          sd(nd) = dsqrt(sas/twopi)
          xd(1,nd) = xv(1)
          xd(2,nd) = xv(2)
          xd(3,nd) = xv(3)
          IF (ndeg.EQ.2) THEN
              nd = nd + 1
              aad(nd) = string(1:30)
              nad(nd) = nat
              strin = string
              WRITE (strin(1:5),500) doname
              WRITE (6,500) strin
              xd(1,nd) = xv(1)
              xd(2,nd) = xv(2)
              xd(3,nd) = xv(3)
          END IF
      END IF
      IF (accep) THEN
          na = na + 1
          aaa(na) = string(1:30)
          naa(na) = nat
          strin = string
          WRITE (strin(1:5),500) acname
          WRITE (6,500) strin
          sa(na) = dsqrt(sas/twopi)
          xa(1,na) = xv(1)
          xa(2,na) = xv(2)
          xa(3,na) = xv(3)
      END IF
      GO TO 2
   98 CONTINUE
      dismx = dsqrt(dismx)
      WRITE (6,602) dismx
  602 FORMAT ('max dist of atom in prot fr center =',f8.3)
      WRITE (6,*) nd,'  donors'
      WRITE (6,*) na,'  acceptors'
      CLOSE (iusas)
      RETURN
      END
      SUBROUTINE chdaca(a,donor,accep,ndeg)
c..This folows HBPLUS  table of donors and acceptors (see ref).
      CHARACTER*7 a
      LOGICAL donor,accep

      donor = .false.
      accep = .false.
      ndeg = 1
c
      IF (a(1:4).EQ.'N   ') donor = .true.
      IF (a(1:6).EQ.'SG  CY') donor = .true.
      IF (a(1:6).EQ.'NE2 HI') donor = .true.
      IF (a(1:6).EQ.'ND1 HI') donor = .true.
      IF (a(1:7).EQ.'NZ  LYS') donor = .true.
      IF (a(1:7).EQ.'ND2 ASN') donor = .true.
      IF (a(1:7).EQ.'NE2 GLN') donor = .true.
      IF (a(1:7).EQ.'NH1 ARG') donor = .true.
      IF (a(1:7).EQ.'NZ  ARG') donor = .true.
      IF (a(1:7).EQ.'NH2 ARG') donor = .true.
      IF (a(1:7).EQ.'OG  SER') donor = .true.
      IF (a(1:7).EQ.'OH  TYR') donor = .true.
      IF (a(1:7).EQ.'NE1 TRP') donor = .true.
      if(a(1:5).eq.'N6  A'  ) donor=.true.
      if(a(1:5).eq.'N4  C'  ) donor=.true.
      if(a(1:5).eq.'N2  G'  ) donor=.true.
c
      IF (a(1:4).EQ.'O   ') accep = .true.
      IF (a(1:6).EQ.'SG  CY') accep = .true.
      IF (a(1:7).EQ.'OD1 ASP') accep = .true.
      IF (a(1:7).EQ.'OD2 ASP') accep = .true.
      IF (a(1:7).EQ.'OE1 GLU') accep = .true.
      IF (a(1:7).EQ.'OE2 GLU') accep = .true.
      IF (a(1:6).EQ.'ND1 HI') accep = .true.
      IF (a(1:7).EQ.'SD  MET') accep = .true.
      IF (a(1:7).EQ.'OD1 ASN') accep = .true.
      IF (a(1:7).EQ.'OE1 GLN') accep = .true.
      IF (a(1:7).EQ.'OG  SER') accep = .true.
      IF (a(1:7).EQ.'OG1 THR') accep = .true.
      IF (a(1:7).EQ.'OH  TYR') accep = .true.
      if(a(1:5).eq.'N7  A'  ) accep=.true.
      if(a(1:5).eq.'N7  G'  ) accep=.true.
      if(a(1:5).eq.'O6  G'  ) accep=.true.
      if(a(1:5).eq.'N3  A'  ) accep=.true.
c next 2 acceptors is mostly occupied by double strands
c but can be used in single stands and RNA
      if(a(1:5).eq.'N3  C'  ) accep=.true.
      IF(A(1:5).eq.'N1  G'  ) accep=.true.

      if(a(1:5).eq.'N3  G'  ) accep=.true.
      if(a(1:5).eq.'O2  T'  ) accep=.true.
      if(a(1:5).eq.'O4  T'  ) accep=.true.
      if(a(1:5).eq.'O4  U'  ) accep=.true.
      if(a(1:5).eq.'O2  U'  ) accep=.true.
      if(a(1:5).eq.'O2  C'  ) accep=.true.
      if(a(1:2).eq."O4'"     ) accep=.true.
c the following acceptor is only present in RNA (OH of sugar)
c but since it is not present in DNA it does not harm there.
      if(a(1:2).eq."O2'"     ) accep=.true.
      if(a(1:4).eq.'O1P '   ) accep=.true.
      if(a(1:4).eq.'O2P '   ) accep=.true.
      if(a(1:4).eq.'P   '   ) accep=.true.

c
      RETURN
      END
      SUBROUTINE chdac(a,donor,accep,ndeg)
c..This folows only charged residue donor-acceptors  (see ref).
c.. + is  donor, - is acceptor
      CHARACTER*7 a
      LOGICAL donor,accep

      donor = .false.
      accep = .false.
      ndeg = 1
      IF (a(1:7).EQ.'NZ  LYS') ndeg = 2
c
      IF (a(1:7).EQ.'NZ  LYS') donor = .true.
      IF (a(1:7).EQ.'NH1 ARG') donor = .true.
      IF (a(1:7).EQ.'NH2 ARG') donor = .true.
c
      IF (a(1:7).EQ.'OD1 ASP') accep = .true.
      IF (a(1:7).EQ.'OD2 ASP') accep = .true.
      IF (a(1:7).EQ.'OE1 GLU') accep = .true.
      IF (a(1:7).EQ.'OE2 GLU') accep = .true.
c
      RETURN
      END
